curvemove = 'cubic-bezier(0.4, 0, 0.2, 1)'
curvein = 'cubic-bezier(0, 0, 0.2, 1)'
curveout = 'cubic-bezier(0.4, 0, 1, 1)'

listview = new Layer width:400, height:0,backgroundColor:'#f7f7f7'
container = new Layer width:400, height:400, backgroundColor:'',rotation:140,				shadowColor:'rgba(0,0,0,0.2)'

container.x = 140
container.y = 240

circle = new Layer backgroundColor:'#4A90E2',borderRadius:'50%',midX:container.width/2, superLayer:container

init = () ->

	container.animate
		properties:
			rotation:0
			midX:Screen.width/2
			midY:Screen.height/2
			opacity:1
		curve:curvein
		time:0.4
	
	godown = circle.animate
		properties:
			y:container.height/2
			scale:0.3
		curve:curvein
		time:0.6
		
	godown.on "end",->
		expand()
		

expand = () ->
	
	ready = circle.animate
		properties:
			scale:0.8		
		curve:curvemove
		time:0.6

	ready.on "end",->
		circle.animate
			properties:
				scale:10
			curve:curvemove
			time:0.6
				
		split = container.animate
			delay:0.6
			properties:
				 height:80
			curve:curvemove
			time:0.6
			 		
		shadow = container.animate
			delay:1.2
			properties:
				 shadowY:2
				 shadowBlur:4
			curve:curvemove
			time:0.6
		
		shadow.on "end",->
			addelements()

addelements = () ->
	 			
	listview.midX = Screen.width/2
	listview.y = container.y+container.height
	
	listview.animate
		properties:
			height:300
		curve:curvemove
		time:0.3
			 			
	fab = new Layer backgroundColor:'#E24C35',borderRadius:'50%',width:60,height:60,scale:0
	fab.x = listview.x+listview.width*0.8
	fab.y = listview.y+200			 			
	fab.shadowColor = 'rgba(0,0,0,0.3)'
	
	appear = fab.animate
		delay:0.3
		properties:
			 scale:1
		curve:curvein
		time:0.6
	
	appear.on "end",->
		moveelements(fab)
		
moveelements = (el) ->
	
	movey = el.animate
		properties:
			shadowY:4
			shadowBlur:8 	
			y:listview.y-listview.height*0.1
		curve:curvemove
		time:0.4
		
	movey.on "end",->
		disappear(el)
			 					
			 					
disappear = (el) ->
	
	el.animate
		properties:
			scale:0
		curve:curveout
		time:0.3
	
	el.on Event.AnimationEnd,-> el.destroy()
			 						
	scaleback = listview.animate
		delay:0.3
		properties:
			 height:0
		curve:curveout	
		time:0.6
	
	scaleback.on "end",->
		goback()

goback = () ->
			 		 						
	container.animate
		delay:0.3
		properties:
			height:400
		curve:curvemove
		time:0.3
	
	gravity = container.animate
		delay:0.3
		properties:
			shadowY:0
			shadowBlur:0
		curve:curvemove
		time:0.3
		
	gravity.on "end",->
		end()
	
end = () ->	

	circle.animate
		properties:
			scale:0.3
		curve:curvemove
		time:0.7
	
		
	fade = container.animate
			delay:0.7
			properties:
				y:240
				x:140
				rotation:160
				opacity:0
			curve:curveout
			time:0.3
			
	fade.on 'end',->
		Utils.delay 1, -> init()
		
init()
																				



